//	*******************************************************************************
//	Name	:	GetDPI.hpp
//			:	GetDpiForWindow
//	Author	:	I. Nakagawa
//	Create	:	2022/10/28
//	Modify	:	2023/05/24		::GetDesktopWindow()
//	Modify	:	2024/06/03		comment ::GetDPI_string()
//	*******************************************************************************

#pragma		once

#include	<Windows.h>

//#include	"t_tstrng.hxx"

////
//	*******************************************************************************
//	GetDpiForWindow
//	Create	:	2022/10/28
//	Modify	:	2023/05/24		::GetDesktopWindow()
//	Modify	:	2024/02/02		call IsWindow()
//	*******************************************************************************
//		UINT	GetDpiForWindow ( [in] HWND hwnd ) ;
typedef	UINT	(WINAPI* P_GDFW)(HWND) ;

inline	UINT	GetDPI	(const HWND hwnd_=NULL)
{
	HWND	hwnd = hwnd_ ;
	if (!::IsWindow(hwnd))	{
			hwnd = NULL ;
		}
	{
		if (hwnd == NULL)	{
			hwnd = ::GetDesktopWindow() ;
			}
		}
	UINT	dpi = 96/2 ;
	HMODULE	user32 = ::GetModuleHandle(TEXT("user32.dll")) ;
	P_GDFW	p_GetDpiForWindow = (P_GDFW)::GetProcAddress(user32,"GetDpiForWindow") ;
	if (p_GetDpiForWindow != NULL) {
		dpi = p_GetDpiForWindow(hwnd) ;
		}
	else {
		HDC	hdc = ::GetDC(hwnd) ;
		dpi = ::GetDeviceCaps(hdc,LOGPIXELSX) ;
		::ReleaseDC(hwnd,hdc) ;
		}
	return	dpi ;
	}

////
//	*******************************************************************************
//	Get DPI scale
//	Create	:	2022/10/28
//	*******************************************************************************
inline	double	GetDPI_scale	(const HWND hwnd=NULL)
{
	UINT	dpi = ::GetDPI(hwnd) ;
	return	dpi/96. ;
	}

/*
////
//	*******************************************************************************
//	DPI 200%
//	Create	:	2023/04/12
//	Modify	:	2023/05/24		::GetDesktopWindow()
//	*******************************************************************************
inline	tstring	GetDPI_string	(void)
{
	tstring	dpi_str ;
	{
		double	dpi_scale    = 1. ;
				dpi_scale    = ::GetDPI_scale() ;		//	desktop window
		#ifdef	_MFC_VER
		{
				HWND	hWnd = ::AfxGetMainWnd()->GetSafeHwnd() ;
				dpi_scale    = ::GetDPI_scale(hWnd) ;
			}
		#endif
		{
		#ifdef	_DEBUG
		#else
			if (dpi_scale != 1.)
		#endif
			{
				dpi_str = _T("  DPI ") + ::To_tstring(long(dpi_scale*100.)) + _T("%") ;
				}
			}
		}
	return	dpi_str ;
	}
*/
