//	**************************************************************************************************
//	Name	:	LateDel.hpp
//			:	call delete at exit
//	Author	:	I. Nakagawa
//	Create	:	2000/06/21
//	Modify	:	2024/06/11
//	**************************************************************************************************

#pragma		once

#include	<afxtempl.h>

class	LateDelete	{
public:
			LateDelete  	()		{	;			}
	virtual	~LateDelete 	()		{	Clear() ;	}
	virtual	BOOL	Clear	(void) ;
public:
	virtual	BOOL	Add 	(void*    bufferPtr)	{	BufferAryV.Add(bufferPtr) ;	return	TRUE ;	}
	virtual	BOOL	Add 	(CObject* bufferPtr)	{	BufferAryO.Add(bufferPtr) ;	return	TRUE ;	}
protected:
	CArray<void*,   void*>  	BufferAryV ;
	CArray<CObject*,CObject*>	BufferAryO ;
	} ;

inline	BOOL	LateDelete::Clear	(void)
{
	int	index ;
	for (index=0 ; index<BufferAryV.GetSize() ; index++) {
		void*	buffer = BufferAryV.GetAt(index) ;
		if (buffer == NULL)		{	continue ;	}
		delete	buffer ;
		BufferAryV.SetAt(index,NULL) ;
		}
	BufferAryV.RemoveAll() ;
	for (index=0 ; index<BufferAryO.GetSize() ; index++) {
		CObject*	buffer = BufferAryO.GetAt(index) ;
		if (buffer == NULL)		{	continue ;	}
		delete	buffer ;
		BufferAryO.SetAt(index,NULL) ;
		}
	BufferAryO.RemoveAll() ;
	return	TRUE ;
	}

