//	*******************************************************************************
//	Name	:	ToolB0607.hpp
//			:	CToolBar resize
//	Author	:	I. Nakagawa
//	Create	:	2024/06/03
//	Modify	:	2024/06/07
//	*******************************************************************************

#pragma		once

#include	"GetDPI.hpp"

////
//	*******************************************************************************
//	CToolBar resize
//	Create	:	2024/06/03
//	Modify	:	2024/06/07
//	*******************************************************************************
inline	BOOL	ToolBar__Resize		(CToolBar* toolBar,UINT idr)
{
	double	dpi_s = 1. ;
	{
			dpi_s = ::GetDPI_scale(toolBar->GetSafeHwnd()) ;
		#ifdef	_DEBUG
			dpi_s *= 2. ;
		#endif
		if (dpi_s == 1.) {
			return	TRUE ;
			}
		}
	CToolBarCtrl&	tbCtrl = toolBar->GetToolBarCtrl() ;
	int	btnCount = 0 ;
	{
		btnCount = tbCtrl.GetButtonCount() ;
		btnCount = tbCtrl.GetImageList()->GetImageCount() ;
		if (btnCount < 1) {
			return	TRUE ;
			}
		}
	CSize	btnSize(0,0) ;
	CRect	bdrRect(0,0,0,0) ;
	{
		DWORD	dwSize = tbCtrl.  GetButtonSize() ;
		{
			btnSize.cx = LOWORD(dwSize) ;
			btnSize.cy = HIWORD(dwSize) ;
			}
		bdrRect        = toolBar->GetBorders() ;
		}
	CSize	newBtnSize = btnSize ;
	CRect	newBdrRect = bdrRect ;
	CSize	newImgSize = btnSize ;
	{
		newBtnSize.cx    = int(btnSize.cx    *dpi_s) ;
		newBtnSize.cy    = int(btnSize.cy    *dpi_s) ;
		newBdrRect.left  = int(bdrRect.left  *dpi_s) ;
		newBdrRect.top   = int(bdrRect.top   *dpi_s) ;
		newBdrRect.right = int(bdrRect.right *dpi_s) ;
		newBdrRect.bottom= int(bdrRect.bottom*dpi_s) ;
		}
	{
		newImgSize.cx    = newBtnSize.cx - 7 ;
		newImgSize.cy    = newBtnSize.cy - 6 ;
		}
	{
		CSize	imageSize    = newImgSize ;
				imageSize.cx*= btnCount ;
		static	CBitmap	newImg ;
		{
			CBitmap	tb_img ;
			tb_img.LoadBitmap(idr) ;
			{
				BITMAP	bm = {0} ;	tb_img.GetBitmap(&bm) ;
				CSize	org_size = CSize(bm.bmWidth,bm.bmHeight) ;
				CDC*	wndDC = toolBar->GetDC() ;
				newImg.CreateCompatibleBitmap(wndDC,imageSize.cx,imageSize.cy) ;
				CDC		srcDC ;		srcDC.CreateCompatibleDC(wndDC) ;
				CDC		dstDC ;		dstDC.CreateCompatibleDC(wndDC) ;
				CBitmap*oldSrcBmp = srcDC.SelectObject(&tb_img) ;
				CBitmap*oldDstBmp = dstDC.SelectObject(&newImg) ;
				::SetStretchBltMode(dstDC.GetSafeHdc(),HALFTONE) ;
				dstDC.StretchBlt(0,0,imageSize.cx,imageSize.cy,&srcDC,0,0,org_size.cx,org_size.cy,SRCCOPY) ;
				srcDC.SelectObject(oldSrcBmp) ;
				dstDC.SelectObject(oldDstBmp) ;
				}
			}
		toolBar->SetBitmap(newImg) ;
		}
	{
		tbCtrl.  SetButtonSize(newBtnSize) ;
		tbCtrl.  SetBitmapSize(newImgSize) ;
		toolBar->SetBorders(newBdrRect) ;
		}
	return	TRUE ;
	}

